-- sort.lua
-- Written By MrJackdaw, tweak by Habna for HugeBag


function Sort()
	if IsSorting or IsMixing or IsMerging or IsSearching then
		write("Can't sort when sort, mix, merge or search function are active!");
		return
	end
	
	--An attempt to make as many variables local to this proc as possible. May avoid the crash? Either way it "feels" right to have as much data disappear as possible.
	local VirtPack
	local item
	local Category
	local CategoryText
	local CatWeight
	local Quality
	local QualWeight
	
	VirtPack = {};
	for i=1,backpackSize do
		VirtPack[i] = {};
		VirtPack[i].id = i;
		item = frmMain.backpack:GetItem(i)
		if item ~= nil then VirtPack[i].Name = item:GetName(); else VirtPack[i].Name = "zEmpty"; end
		VirtPack[i].Weight=weight(i)
	end

	--Sort VirtPack. If the weight of two items is the same compare the Names, after removing some characters. This way "2 Morale Potions" will get sorted with "Morale Potions"
	table.sort(VirtPack, function (a,b)	
		if a.Weight == b.Weight then 
			--return a.Name < b.Name
			return strip(a.Name)< strip(b.Name)
		else  
			return (a.Weight < b.Weight) 
		end
		end)
	
	IsSorting = true;
	SortButton:SetVisible( false );
	SearchButton:SetVisible( false );
	MergeButton:SetVisible( false );

	Slot = 1;
	write( "HugeBag: Sorting started" );
	Start= Turbine.Engine.GetGameTime()
	Timer = Turbine.UI.Control();
	Timer:SetWantsUpdates(true);

	Timer.Update = function( sender, args )
		if Slot > backpackSize then
			Timer:SetWantsUpdates(false);

			if ShowButton then
				SortButton:SetVisible( true );
				SearchButton:SetVisible( true );
				MergeButton:SetVisible( true );
			end
	
			IsSorting = false;
			write( "HugeBag: Sorting finished" );
			local Time = Turbine.Engine.GetGameTime();
			local elapsed = Time - Start;
			write("<rgb=#888888>Sort finished after ".. elapsed .." seconds.")
			--Turbine.PluginManager.LoadPlugin( 'HugeBag Reloader' );
		end
		
		if Slot > backpackSize then return end
		
		--[[ This method take more time 1.8 secs compare to 1.04/1.1/1.2 secs		
		--Get the name of the target item
		targetName = VirtPack[Slot].Name;

		--Get item in current slot
		itemSlot = frmMain.backpack:GetItem(Slot);

		--Get the name of the item in the current slot. If empty return that name as "zEmpty"
		if itemSlot ~= nil then itemName = itemSlot:GetName(); else itemName = "zEmpty"; end

		--If the Name of the current item is equal to the target name, move on.
		if itemName == targetName then Slot = Slot + 1; return end
		
		--Search for the item in the rest of the pack.
		for i = Slot + 1, backpackSize do
			item = frmMain.backpack:GetItem(i);
			if item ~= nil then itemName = item:GetName(); else itemName = "zEmpty"; end

			if itemName == targetName then
				if item ~= nil then frmMain.backpack:PerformItemDrop(item, Slot, false); end
				Slot = Slot + 1;
				return
			end
		end
		]]

		--Get the name of the target item
		targetName = VirtPack[Slot].Name;

		--Search for the item in the rest of the pack.
		for i = 1, backpackSize do
			item = frmMain.backpack:GetItem(i);
			if item ~= nil then itemName = item:GetName(); else itemName = "zEmpty"; end

			if itemName == targetName then
				if item ~= nil then frmMain.backpack:PerformItemDrop(item, Slot, false); end
				Slot = Slot + 1;
				return
			end
		end
	end
end

function weight(i)
	item=frmMain.backpack:GetItem(i)
		
	if item == nil then
		--Empty slots have no name, quality, category etc
		Category=0
		Quality=0
	else
		Category=item:GetCategory()
		Quality=item:GetQuality()
		if Quality==nil then Quality=0 end
	end

	--Calculate the weight
	local Weight = 0
			
	CategoryText=ItemCategory[Category]
	if CategoryText~=nil then					
		CatWeight=value[CategoryText]		--First scan the CategoryText using the value table Note:This will bug out if Turbine add any new item categories!
	else
		--This item has not been given a category number by turbine - it is missing from the category text list.
		write("<rgb=#888888>"..item:GetName().." has not been given category text by Turbine. Dammit. It's number is "..Category.." Please inform MrJackdaw!")
		CatWeight=1
	end
			
	QualWeight=Quality
	Weight=CatWeight*10+QualWeight
	
	if item==nil then Weight = 99999 end
					
	return Weight
end

function strip(str)
	--Strip numbers first 7 characters to make the sort more logical
	local left=string.sub(str, 1, 7)
	local right=string.sub(str, 8)
	left=string.gsub(left,"[^%a]","")
	str= left .. right
	--Strip all spaces now!
	str=string.gsub(str,"[%s]","")
	return str
end